# CMake file
# Copyright (C) ZIH, Technische Universitaet Dresden, Federal Republic of Germany, 2011-2011
# Copyright (C) Lawrence Livermore National Laboratories, United States of America, 2011-2011
#
# TODO Martin please add the copyright statment of your choice, as well as 
#      a reference to the license or license file!
#
# @file FeatureTests.cmake
#       CMake file for running feature tests.
#
# @author Mathias Korepkat, Tobias Hilbrich
# @date 25.11.2011

###Run all feature tests that influence config.h
#MPI-2 constants
featureTestMpi ("ft_mpi_status_ignore.c" C HAVE_MPI_STATUS_IGNORE)
featureTestMpi ("ft_mpi_statuses_ignore.c" C HAVE_MPI_STATUSES_IGNORE)
featureTestMpi ("ft_mpi_f_status_ignore.c" C HAVE_MPI_F_STATUS_IGNORE)
featureTestMpi ("ft_mpi_f_statuses_ignore.c" C HAVE_MPI_F_STATUSES_IGNORE)

# handle convert macros may be present
##@TODO we also have feature tests for the other handles, we just didn't have the time to 
##handle them correctly in the existing stuff, so right now just what we use
##@NOTE These tests are CPP as for MPICH2(?) the Request_c2f/f2c stuff is broken for 
##CPP (but nor for C); with that we see the issue there and do not use them for this MPI, 
##which is a good choice
SET (HandleConvertMacros
    MPI_STATUS_C2F
    CACHE INTERNAL "All the handle convert macros"
)

FOREACH (type ${HandleConvertMacros})
    STRING (TOLOWER ${type} type_lower)
    featureTestMpi ( "ft_${type_lower}2c.cpp" CXX HAVE_${type})
ENDFOREACH (type)
